package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CompanyInfo;
import com.izouma.awesomeadmin.service.CompanyInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/companyInfo")
public class CompanyInfoController extends BaseController{

    @Autowired
    private CompanyInfoService companyInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CompanyInfo record) {
        List<CompanyInfo> pp = companyInfoService.getCompanyInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCompanyInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getCompanyInfo(@RequestParam(required = false, value = "id") String id) {
        CompanyInfo data = companyInfoService.getCompanyInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CompanyInfo record) {
        CompanyInfo data = companyInfoService.getCompanyInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CompanyInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<CompanyInfo> pp =companyInfoService.getCompanyInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CompanyInfo record) {
        boolean num = companyInfoService.createCompanyInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCompanyInfo(CompanyInfo record) {
        boolean num = companyInfoService.updateCompanyInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCompanyInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = companyInfoService.deleteCompanyInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CompanyInfo record) throws Exception {

    List<CompanyInfo> companyInfos = companyInfoService.getCompanyInfoList(record);


        String sheetName = "company_info";
        String titleName = "公司简介数据表";
        String fileName = "公司简介表";
        int columnNumber = 5;
        int[] columnWidth = { 20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "标题" ,   "介绍" ,   ""  };
        String[][] dataList = new String[companyInfos.size()][5];

        for (int i = 0; i < companyInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(companyInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(companyInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(companyInfos.get(i).getTitle());
                        dataList[i][3] = String.valueOf(companyInfos.get(i).getRemark());
                        dataList[i][4] = String.valueOf(companyInfos.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

